import { DataItem } from '@antv/g2plot/esm/interface/config';

export { DataItem };

/** 主题数、课程数统计 */
export interface SubjectAndCourseNumberStatistics{
  course_numbers:	number; //课程总数		
  subject_numbers: number;	//主题总数	
}

/** 培训情况统计，按照主题统计关联培训的数量 */
export interface TrainNumberBySubjectStatistics{
  subject_train_list: 	// 主题与培训统计列表	
  [
    {
      subject_id: number;	// 主题id		
      subject_name: string;	// 主题名称		
      train_number: string;	//主题关联培训数
    }
  ]
  train_numbers: number;	//培训总数		
}

/** 课程浏览量统计 */
export interface CourseBrowseTimesStatistics{
  data: [
    {
      browse_times: number;	//课程浏览量		
      course_id: number;	//课程id		
      course_name: string;	//课程名称
    }
  ]
}