import { Card, Col, Row, Tabs } from 'antd';
import { DualAxes } from '@ant-design/plots';

import styles from '../style.less';
// import { useRequest } from 'react';
import { getCredentialPersonStatistics } from '../service';
import cookie from 'react-cookies';
import { useRequest } from 'umi';
export type TimeType = 'today' | 'week' | 'month' | 'year';


const { TabPane } = Tabs;
// const credentialPersonStatistics = await getCredentialPersonStatistics({
//   province_id: cookie.load('background_province_id')
// });


const SalesCard = () => {
  const { loading: courseBrowseTimesLoading, data: credentialPersonStatistics = null } = useRequest(() => getCredentialPersonStatistics({
    province_id: cookie.load('background_province_id')
  }), {
    formatResult: (result) => {
      return result.list;
    }
  });

  const data = []
  // console.log(credentialPersonStatistics, 'credentialPersonStatistics')

  credentialPersonStatistics?.map((e, i) => {

    data.push({
      city: e.city_name,
      count: e.count,
      credential_rate: e.credential_rate
    })
  })

  const config = {
    data: [data, data],
    xField: 'city',
    yField: ['count', 'credential_rate'],
    yAxis: [{
      title: {
        text: '资质证书人数',
      },
    }, {
      title: {
        text: '证书比例',
      },
    }],
    geometryOptions: [
      {
        geometry: 'column',
      },
      {

        geometry: 'line',
        lineStyle: {
          lineWidth: 2,
        },
      },
    ],
  };
  return (<Card bordered={false} bodyStyle={{ padding: 0, marginBottom: '24px' }}>
    <div className={styles.salesCard}>
      <Tabs
        size="large"
        tabBarStyle={{ marginBottom: 24 }}
      >
        <TabPane tab="各市州资质证书情况" key="train">
          <Row>
            <Col xl={24} lg={24} md={24} sm={24} xs={24}>
              <div className={styles.salesBar}>
                <DualAxes {...config} />

              </div>
            </Col>
          </Row>
        </TabPane>

      </Tabs>
    </div>
  </Card>
  )
};

export default SalesCard;
